Index: trunk/kBuild/sdks/MACOSX110.kmk
===================================================================
--- trunk/kBuild/sdks/MACOSX110.kmk	(revision 3495)
+++ trunk/kBuild/sdks/MACOSX110.kmk	(revision 3495)
@@ -0,0 +1,62 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v11.0 SDK.
+#
+
+#
+# Copyright (c) 2008-2020 knut st. osmundsen <bird-kBuild-spam-xx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef INCLUDED_DARWIN_COMMON_KMK
+ include $(KBUILD_PATH)/darwin-common.kmk
+endif
+
+SDK_MACOSX110 := Mac OS X v11.0 SDK
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX110
+ PATH_SDK_MACOSX110 := $(call DARWINCMN_FN_FIND_MACOSX_SDK,MacOSX11.0.sdk)
+else
+ # Resolve any fancy stuff once and for all.
+ PATH_SDK_MACOSX110 := $(PATH_SDK_MACOSX110)
+endif
+ifeq ($(PATH_SDK_MACOSX110),)
+ $(warning $(call DARWINCMN_FN_ERROR_MACOSX_SDK,MacOSX11.0.sdk))
+endif
+
+## The MAC_OS_X_VERSION_MIN_REQUIRED and MAC_OS_X_VERSION_MAX_ALLOWED value for this SDK.
+SDK_MACOSX110_VERSION_VALUE := 110000
+
+# General Properties (used by kBuild)
+# Note: The MAC_OS_X_VERSION_MAX_ALLOWED is left free for the SDK user to define.
+SDK_MACOSX110_DEFS        ?= MAC_OS_X_VERSION_MIN_REQUIRED=110000
+SDK_MACOSX110_CFLAGS      ?= -mmacosx-version-min=11.0 -isysroot "$(PATH_SDK_MACOSX110)"
+SDK_MACOSX110_CXXFLAGS    ?= -mmacosx-version-min=11.0 -isysroot "$(PATH_SDK_MACOSX110)"
+SDK_MACOSX110_OBJCFLAGS   ?= -mmacosx-version-min=11.0 -isysroot "$(PATH_SDK_MACOSX110)"
+SDK_MACOSX110_OBJCXXFLAGS ?= -mmacosx-version-min=11.0 -isysroot "$(PATH_SDK_MACOSX110)"
+SDK_MACOSX110_LDFLAGS     ?= -mmacosx-version-min=11.0 -isysroot "$(PATH_SDK_MACOSX110)"
+
Index: trunk/kBuild/sdks/MACOSX110INCS.kmk
===================================================================
--- trunk/kBuild/sdks/MACOSX110INCS.kmk	(revision 3495)
+++ trunk/kBuild/sdks/MACOSX110INCS.kmk	(revision 3495)
@@ -0,0 +1,49 @@
+# $Id$
+## @file
+# kBuild SDK - Mac OS X v11.0 SDK, includes only.
+#
+
+#
+# Copyright (c) 2008-2020 knut st. osmundsen <bird-kBuild-spam-xx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef SDK_MACOSX110
+ include $(KBUILD_PATH)/sdks/MACOSX110.kmk
+endif
+
+SDK_MACOSX110INCS := Mac OS X v11.0 SDK, include only.
+
+# SDK Specific Properties
+ifndef PATH_SDK_MACOSX110INCS
+ PATH_SDK_MACOSX110INCS := $(PATH_SDK_MACOSX110)
+else
+ PATH_SDK_MACOSX110INCS := $(PATH_SDK_MACOSX110INCS)
+endif
+
+# General Properties (used by kBuild)
+SDK_MACOSX110INCS_INCS = $(PATH_SDK_MACOSX110INCS)/usr/include
+