Index: trunk/kBuild/sdks/WINSDK10-KM-W8.kmk
===================================================================
--- trunk/kBuild/sdks/WINSDK10-KM-W8.kmk	(revision 3507)
+++ trunk/kBuild/sdks/WINSDK10-KM-W8.kmk	(revision 3507)
@@ -0,0 +1,51 @@
+# $Id$
+## @file
+# kBuild SDK - Derives from WINSDK10.kmk, kernel mode, Targeting Windows 8 (KBUILD_TARGET_ARCH).
+#
+
+#
+# Copyright (c) 2006-2021 knut st. osmundsen <bird-kBuild-spam-xviiv@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef SDK_WINSDK10
+ include $(KBUILD_PATH)/sdks/WINSDK10-KM.kmk
+endif
+
+SDK_WINSDK10-KM-W8               := The Microsoft Windows 10 SDK, kernel mode, Targeting Windows 8 (KBUILD_TARGET_ARCH).
+SDK_WINSDK10-KM-W8_EXTENDS       := WINSDK10-KM
+SDK_WINSDK10-KM-W8_DEFS          ?= WIN32=100 _WIN32_WINNT=0x0602 WINVER=0x0602 _WIN32_IE=0x0A00 NTDDI_VERSION=0x06020000 \
+	KMDF_MAJOR_VERSION=01 KMDF_MINOR_VERSION=005
+SDK_WINSDK10-KM-W8_LIBPATH.x86   ?= $(PATH_SDK_WINSDK10_KM_LIB_W8.x86)
+SDK_WINSDK10-KM-W8_LIBPATH.amd64 ?= $(PATH_SDK_WINSDK10_KM_LIB_W8.amd64)
+SDK_WINSDK10-KM-W8_LIBPATH.arm32 ?= $(PATH_SDK_WINSDK10_KM_LIB_W8.arm32)
+
+# SDK Specific Properties.
+PATH_SDK_WINSDK10-KM-W8_LIB.x86  ?= $(PATH_SDK_WINSDK10_KM_LIB_W8.x86)
+PATH_SDK_WINSDK10-KM-W8_LIB.amd64?= $(PATH_SDK_WINSDK10_KM_LIB_W8.amd64)
+PATH_SDK_WINSDK10-KM-W8_LIB.arm32?= $(PATH_SDK_WINSDK10_KM_LIB_W8.arm32)
+PATH_SDK_WINSDK10-KM-W8_LIB      ?= $(PATH_SDK_WINSDK10-KM-W8_LIB.$(KBUILD_TARGET_ARCH))
+
Index: trunk/kBuild/sdks/WINSDK10-KM.kmk
===================================================================
--- trunk/kBuild/sdks/WINSDK10-KM.kmk	(revision 3507)
+++ trunk/kBuild/sdks/WINSDK10-KM.kmk	(revision 3507)
@@ -0,0 +1,59 @@
+# $Id$
+## @file
+# kBuild SDK - Derives from WINSDK10.kmk, kernel mode.
+#
+
+#
+# Copyright (c) 2006-2020 knut st. osmundsen <bird-kBuild-spam-xx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+ifndef SDK_WINSDK10
+ include $(KBUILD_PATH)/sdks/WINSDK10.kmk
+endif
+
+SDK_WINSDK10-KM               := The Microsoft Windows 10 SDK, kernel mode.
+SDK_WINSDK10-KM_DEFS.amd64    ?= _AMD64_ AMD64 _WIN64
+SDK_WINSDK10-KM_DEFS.x86      ?= _X86_=1 i386=1 STD_CALL
+SDK_WINSDK10-KM_DEFS.arm32    ?= #??
+SDK_WINSDK10-KM_DEFS.arm64    ?= #??
+SDK_WINSDK10-KM_INCS          ?= \
+	$(PATH_SDK_WINSDK10_KM_INC) \
+	$(PATH_SDK_WINSDK10_SHARED_INC)
+SDK_WINSDK10-KM_LIBPATH.x86   ?= $(PATH_SDK_WINSDK10_KM_LIB.x86)
+SDK_WINSDK10-KM_LIBPATH.amd64 ?= $(PATH_SDK_WINSDK10_KM_LIB.amd64)
+SDK_WINSDK10-KM_LIBPATH.arm32 ?= $(PATH_SDK_WINSDK10_KM_LIB.arm32)
+SDK_WINSDK10-KM_LIBPATH.arm64 ?= $(PATH_SDK_WINSDK10_KM_LIB.arm64)
+
+# Path variables for smoothing the transistion from older PSDKs.
+PATH_SDK_WINSDK10_KM           = $(PATH_SDK_WINSDK10)
+
+PATH_SDK_WINSDK10-KM_LIB.x86   = $(PATH_SDK_WINSDK10_KM_LIB.x86)
+PATH_SDK_WINSDK10-KM_LIB.amd64 = $(PATH_SDK_WINSDK10_KM_LIB.amd64)
+PATH_SDK_WINSDK10-KM_LIB.arm32 = $(PATH_SDK_WINSDK10_KM_LIB.arm32)
+PATH_SDK_WINSDK10-KM_LIB.arm64 = $(PATH_SDK_WINSDK10_KM_LIB.arm64)
+PATH_SDK_WINSDK10-KM_LIB      ?= $(PATH_SDK_WINSDK10_KM_LIB.$(KBUILD_TARGET_ARCH))
+
Index: trunk/kBuild/sdks/WINSDK10.kmk
===================================================================
--- trunk/kBuild/sdks/WINSDK10.kmk	(revision 3503)
+++ trunk/kBuild/sdks/WINSDK10.kmk	(revision 3507)
@@ -172,4 +172,6 @@
 PATH_SDK_WINSDK10_KM_INC := $(PATH_SDK_WINSDK10_BASE_INC)/$(SDK_WINSDK10_VERSION)/km
 endif
+
+# Kernel-mode API libraries (WDK).
 ifndef PATH_SDK_WINSDK10_KM_LIB.amd64
 PATH_SDK_WINSDK10_KM_LIB.amd64 := $(PATH_SDK_WINSDK10_BASE_LIB)/$(SDK_WINSDK10_VERSION)/km/x64
@@ -185,4 +187,37 @@
 endif
 PATH_SDK_WINSDK10_KM_LIB = $(PATH_SDK_WINSDK10_KM_LIB.$(KBUILD_TARGET_ARCH))
+
+# Kernel-mode API libraries for Windows 7 (WDK).
+ifndef PATH_SDK_WINSDK10_KM_LIB_W7.amd64
+PATH_SDK_WINSDK10_KM_LIB_W7.amd64 := $(PATH_SDK_WINSDK10_BASE_LIB)/win7/km/x64
+endif
+ifndef PATH_SDK_WINSDK10_KM_LIB_W7.x86
+PATH_SDK_WINSDK10_KM_LIB_W7.x86 := $(PATH_SDK_WINSDK10_BASE_LIB)/win7/km/x86
+endif
+PATH_SDK_WINSDK10_KM_LIB_W7 = $(PATH_SDK_WINSDK10_KM_LIB_W7.$(KBUILD_TARGET_ARCH))
+
+# Kernel-mode API libraries for Windows 8 (WDK).
+ifndef PATH_SDK_WINSDK10_KM_LIB_W8.amd64
+PATH_SDK_WINSDK10_KM_LIB_W8.amd64 := $(PATH_SDK_WINSDK10_BASE_LIB)/win8/km/x64
+endif
+ifndef PATH_SDK_WINSDK10_KM_LIB_W8.arm32
+PATH_SDK_WINSDK10_KM_LIB_W8.arm32 := $(PATH_SDK_WINSDK10_BASE_LIB)/win8/km/arm
+endif
+ifndef PATH_SDK_WINSDK10_KM_LIB_W8.x86
+PATH_SDK_WINSDK10_KM_LIB_W8.x86 := $(PATH_SDK_WINSDK10_BASE_LIB)/win8/km/x86
+endif
+PATH_SDK_WINSDK10_KM_LIB_W8 = $(PATH_SDK_WINSDK10_KM_LIB_W8.$(KBUILD_TARGET_ARCH))
+
+# Kernel-mode API libraries for Windows 8.1 (WDK).
+ifndef PATH_SDK_WINSDK10_KM_LIB_W81.amd64
+PATH_SDK_WINSDK10_KM_LIB_W81.amd64 := $(PATH_SDK_WINSDK10_BASE_LIB)/winv6.3/km/x64
+endif
+ifndef PATH_SDK_WINSDK10_KM_LIB_W81.arm32
+PATH_SDK_WINSDK10_KM_LIB_W81.arm32 := $(PATH_SDK_WINSDK10_BASE_LIB)/winv6.3/km/arm
+endif
+ifndef PATH_SDK_WINSDK10_KM_LIB_W81.x86
+PATH_SDK_WINSDK10_KM_LIB_W81.x86 := $(PATH_SDK_WINSDK10_BASE_LIB)/winv6.3/km/x86
+endif
+PATH_SDK_WINSDK10_KM_LIB_W81 = $(PATH_SDK_WINSDK10_KM_LIB_W81.$(KBUILD_TARGET_ARCH))
 
 # Binary directory for host.